merge-recursive: get rid of virtual_id
[git.git] / git-rebase--interactive.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2006 Johannes E. Schindelin
4
5 # SHORT DESCRIPTION
6 #
7 # This script makes it easy to fix up commits in the middle of a series,
8 # and rearrange commits.
9 #
10 # The original idea comes from Eric W. Biederman, in
11 # http://article.gmane.org/gmane.comp.version-control.git/22407
12
13 OPTIONS_KEEPDASHDASH=
14 OPTIONS_SPEC="\
15 git-rebase [-i] [options] [--] <upstream> [<branch>]
16 git-rebase [-i] (--continue | --abort | --skip)
17 --
18  Available options are
19 v,verbose          display a diffstat of what changed upstream
20 onto=              rebase onto given branch instead of upstream
21 p,preserve-merges  try to recreate merges instead of ignoring them
22 s,strategy=        use the given merge strategy
23 m,merge            always used (no-op)
24 i,interactive      always used (no-op)
25  Actions:
26 continue           continue rebasing process
27 abort              abort rebasing process and restore original branch
28 skip               skip current patch and continue rebasing process
29 "
30
31 . git-sh-setup
32 require_work_tree
33
34 DOTEST="$GIT_DIR/rebase-merge"
35 TODO="$DOTEST"/git-rebase-todo
36 DONE="$DOTEST"/done
37 MSG="$DOTEST"/message
38 SQUASH_MSG="$DOTEST"/message-squash
39 REWRITTEN="$DOTEST"/rewritten
40 PRESERVE_MERGES=
41 STRATEGY=
42 ONTO=
43 VERBOSE=
44
45 GIT_CHERRY_PICK_HELP="  After resolving the conflicts,
46 mark the corrected paths with 'git add <paths>', and
47 run 'git rebase --continue'"
48 export GIT_CHERRY_PICK_HELP
49
50 warn () {
51         echo "$*" >&2
52 }
53
54 output () {
55         case "$VERBOSE" in
56         '')
57                 output=$("$@" 2>&1 )
58                 status=$?
59                 test $status != 0 && printf "%s\n" "$output"
60                 return $status
61                 ;;
62         *)
63                 "$@"
64                 ;;
65         esac
66 }
67
68 require_clean_work_tree () {
69         # test if working tree is dirty
70         git rev-parse --verify HEAD > /dev/null &&
71         git update-index --ignore-submodules --refresh &&
72         git diff-files --quiet --ignore-submodules &&
73         git diff-index --cached --quiet HEAD --ignore-submodules -- ||
74         die "Working tree is dirty"
75 }
76
77 ORIG_REFLOG_ACTION="$GIT_REFLOG_ACTION"
78
79 comment_for_reflog () {
80         case "$ORIG_REFLOG_ACTION" in
81         ''|rebase*)
82                 GIT_REFLOG_ACTION="rebase -i ($1)"
83                 export GIT_REFLOG_ACTION
84                 ;;
85         esac
86 }
87
88 last_count=
89 mark_action_done () {
90         sed -e 1q < "$TODO" >> "$DONE"
91         sed -e 1d < "$TODO" >> "$TODO".new
92         mv -f "$TODO".new "$TODO"
93         count=$(grep -c '^[^#]' < "$DONE")
94         total=$(($count+$(grep -c '^[^#]' < "$TODO")))
95         if test "$last_count" != "$count"
96         then
97                 last_count=$count
98                 printf "Rebasing (%d/%d)\r" $count $total
99                 test -z "$VERBOSE" || echo
100         fi
101 }
102
103 make_patch () {
104         parent_sha1=$(git rev-parse --verify "$1"^) ||
105                 die "Cannot get patch for $1^"
106         git diff-tree -p "$parent_sha1".."$1" > "$DOTEST"/patch
107         test -f "$DOTEST"/message ||
108                 git cat-file commit "$1" | sed "1,/^$/d" > "$DOTEST"/message
109         test -f "$DOTEST"/author-script ||
110                 get_author_ident_from_commit "$1" > "$DOTEST"/author-script
111 }
112
113 die_with_patch () {
114         make_patch "$1"
115         git rerere
116         die "$2"
117 }
118
119 die_abort () {
120         rm -rf "$DOTEST"
121         die "$1"
122 }
123
124 has_action () {
125         grep '^[^#]' "$1" >/dev/null
126 }
127
128 pick_one () {
129         no_ff=
130         case "$1" in -n) sha1=$2; no_ff=t ;; *) sha1=$1 ;; esac
131         output git rev-parse --verify $sha1 || die "Invalid commit name: $sha1"
132         test -d "$REWRITTEN" &&
133                 pick_one_preserving_merges "$@" && return
134         parent_sha1=$(git rev-parse --verify $sha1^) ||
135                 die "Could not get the parent of $sha1"
136         current_sha1=$(git rev-parse --verify HEAD)
137         if test "$no_ff$current_sha1" = "$parent_sha1"; then
138                 output git reset --hard $sha1
139                 test "a$1" = a-n && output git reset --soft $current_sha1
140                 sha1=$(git rev-parse --short $sha1)
141                 output warn Fast forward to $sha1
142         else
143                 output git cherry-pick "$@"
144         fi
145 }
146
147 pick_one_preserving_merges () {
148         fast_forward=t
149         case "$1" in
150         -n)
151                 fast_forward=f
152                 sha1=$2
153                 ;;
154         *)
155                 sha1=$1
156                 ;;
157         esac
158         sha1=$(git rev-parse $sha1)
159
160         if test -f "$DOTEST"/current-commit
161         then
162                 current_commit=$(cat "$DOTEST"/current-commit) &&
163                 git rev-parse HEAD > "$REWRITTEN"/$current_commit &&
164                 rm "$DOTEST"/current-commit ||
165                 die "Cannot write current commit's replacement sha1"
166         fi
167
168         echo $sha1 > "$DOTEST"/current-commit
169
170         # rewrite parents; if none were rewritten, we can fast-forward.
171         new_parents=
172         for p in $(git rev-list --parents -1 $sha1 | cut -d' ' -f2-)
173         do
174                 if test -f "$REWRITTEN"/$p
175                 then
176                         new_p=$(cat "$REWRITTEN"/$p)
177                         test $p != $new_p && fast_forward=f
178                         case "$new_parents" in
179                         *$new_p*)
180                                 ;; # do nothing; that parent is already there
181                         *)
182                                 new_parents="$new_parents $new_p"
183                                 ;;
184                         esac
185                 else
186                         new_parents="$new_parents $p"
187                 fi
188         done
189         case $fast_forward in
190         t)
191                 output warn "Fast forward to $sha1"
192                 output git reset --hard $sha1 ||
193                         die "Cannot fast forward to $sha1"
194                 ;;
195         f)
196                 test "a$1" = a-n && die "Refusing to squash a merge: $sha1"
197
198                 first_parent=$(expr "$new_parents" : ' \([^ ]*\)')
199                 # detach HEAD to current parent
200                 output git checkout $first_parent 2> /dev/null ||
201                         die "Cannot move HEAD to $first_parent"
202
203                 case "$new_parents" in
204                 ' '*' '*)
205                         # redo merge
206                         author_script=$(get_author_ident_from_commit $sha1)
207                         eval "$author_script"
208                         msg="$(git cat-file commit $sha1 | sed -e '1,/^$/d')"
209                         # No point in merging the first parent, that's HEAD
210                         new_parents=${new_parents# $first_parent}
211                         if ! GIT_AUTHOR_NAME="$GIT_AUTHOR_NAME" \
212                                 GIT_AUTHOR_EMAIL="$GIT_AUTHOR_EMAIL" \
213                                 GIT_AUTHOR_DATE="$GIT_AUTHOR_DATE" \
214                                 output git merge $STRATEGY -m "$msg" \
215                                         $new_parents
216                         then
217                                 git rerere
218                                 printf "%s\n" "$msg" > "$GIT_DIR"/MERGE_MSG
219                                 die Error redoing merge $sha1
220                         fi
221                         ;;
222                 *)
223                         output git cherry-pick "$@" ||
224                                 die_with_patch $sha1 "Could not pick $sha1"
225                         ;;
226                 esac
227                 ;;
228         esac
229 }
230
231 nth_string () {
232         case "$1" in
233         *1[0-9]|*[04-9]) echo "$1"th;;
234         *1) echo "$1"st;;
235         *2) echo "$1"nd;;
236         *3) echo "$1"rd;;
237         esac
238 }
239
240 make_squash_message () {
241         if test -f "$SQUASH_MSG"; then
242                 COUNT=$(($(sed -n "s/^# This is [^0-9]*\([1-9][0-9]*\).*/\1/p" \
243                         < "$SQUASH_MSG" | sed -ne '$p')+1))
244                 echo "# This is a combination of $COUNT commits."
245                 sed -e 1d -e '2,/^./{
246                         /^$/d
247                 }' <"$SQUASH_MSG"
248         else
249                 COUNT=2
250                 echo "# This is a combination of two commits."
251                 echo "# The first commit's message is:"
252                 echo
253                 git cat-file commit HEAD | sed -e '1,/^$/d'
254         fi
255         echo
256         echo "# This is the $(nth_string $COUNT) commit message:"
257         echo
258         git cat-file commit $1 | sed -e '1,/^$/d'
259 }
260
261 peek_next_command () {
262         sed -n "1s/ .*$//p" < "$TODO"
263 }
264
265 do_next () {
266         rm -f "$DOTEST"/message "$DOTEST"/author-script \
267                 "$DOTEST"/amend || exit
268         read command sha1 rest < "$TODO"
269         case "$command" in
270         '#'*|'')
271                 mark_action_done
272                 ;;
273         pick|p)
274                 comment_for_reflog pick
275
276                 mark_action_done
277                 pick_one $sha1 ||
278                         die_with_patch $sha1 "Could not apply $sha1... $rest"
279                 ;;
280         edit|e)
281                 comment_for_reflog edit
282
283                 mark_action_done
284                 pick_one $sha1 ||
285                         die_with_patch $sha1 "Could not apply $sha1... $rest"
286                 make_patch $sha1
287                 : > "$DOTEST"/amend
288                 warn "Stopped at $sha1... $rest"
289                 warn "You can amend the commit now, with"
290                 warn
291                 warn "  git commit --amend"
292                 warn
293                 warn "Once you are satisfied with your changes, run"
294                 warn
295                 warn "  git rebase --continue"
296                 warn
297                 exit 0
298                 ;;
299         squash|s)
300                 comment_for_reflog squash
301
302                 has_action "$DONE" ||
303                         die "Cannot 'squash' without a previous commit"
304
305                 mark_action_done
306                 make_squash_message $sha1 > "$MSG"
307                 case "$(peek_next_command)" in
308                 squash|s)
309                         EDIT_COMMIT=
310                         USE_OUTPUT=output
311                         cp "$MSG" "$SQUASH_MSG"
312                         ;;
313                 *)
314                         EDIT_COMMIT=-e
315                         USE_OUTPUT=
316                         rm -f "$SQUASH_MSG" || exit
317                         ;;
318                 esac
319
320                 failed=f
321                 author_script=$(get_author_ident_from_commit HEAD)
322                 output git reset --soft HEAD^
323                 pick_one -n $sha1 || failed=t
324                 echo "$author_script" > "$DOTEST"/author-script
325                 if test $failed = f
326                 then
327                         # This is like --amend, but with a different message
328                         eval "$author_script"
329                         GIT_AUTHOR_NAME="$GIT_AUTHOR_NAME" \
330                         GIT_AUTHOR_EMAIL="$GIT_AUTHOR_EMAIL" \
331                         GIT_AUTHOR_DATE="$GIT_AUTHOR_DATE" \
332                         $USE_OUTPUT git commit --no-verify -F "$MSG" $EDIT_COMMIT || failed=t
333                 fi
334                 if test $failed = t
335                 then
336                         cp "$MSG" "$GIT_DIR"/MERGE_MSG
337                         warn
338                         warn "Could not apply $sha1... $rest"
339                         die_with_patch $sha1 ""
340                 fi
341                 ;;
342         *)
343                 warn "Unknown command: $command $sha1 $rest"
344                 die_with_patch $sha1 "Please fix this in the file $TODO."
345                 ;;
346         esac
347         test -s "$TODO" && return
348
349         comment_for_reflog finish &&
350         HEADNAME=$(cat "$DOTEST"/head-name) &&
351         OLDHEAD=$(cat "$DOTEST"/head) &&
352         SHORTONTO=$(git rev-parse --short $(cat "$DOTEST"/onto)) &&
353         if test -d "$REWRITTEN"
354         then
355                 test -f "$DOTEST"/current-commit &&
356                         current_commit=$(cat "$DOTEST"/current-commit) &&
357                         git rev-parse HEAD > "$REWRITTEN"/$current_commit
358                 if test -f "$REWRITTEN"/$OLDHEAD
359                 then
360                         NEWHEAD=$(cat "$REWRITTEN"/$OLDHEAD)
361                 else
362                         NEWHEAD=$OLDHEAD
363                 fi
364         else
365                 NEWHEAD=$(git rev-parse HEAD)
366         fi &&
367         case $HEADNAME in
368         refs/*)
369                 message="$GIT_REFLOG_ACTION: $HEADNAME onto $SHORTONTO)" &&
370                 git update-ref -m "$message" $HEADNAME $NEWHEAD $OLDHEAD &&
371                 git symbolic-ref HEAD $HEADNAME
372                 ;;
373         esac && {
374                 test ! -f "$DOTEST"/verbose ||
375                         git diff-tree --stat $(cat "$DOTEST"/head)..HEAD
376         } &&
377         rm -rf "$DOTEST" &&
378         git gc --auto &&
379         warn "Successfully rebased and updated $HEADNAME."
380
381         exit
382 }
383
384 do_rest () {
385         while :
386         do
387                 do_next
388         done
389 }
390
391 # check if no other options are set
392 is_standalone () {
393         test $# -eq 2 -a "$2" = '--' &&
394         test -z "$ONTO" &&
395         test -z "$PRESERVE_MERGES" &&
396         test -z "$STRATEGY" &&
397         test -z "$VERBOSE"
398 }
399
400 get_saved_options () {
401         test -d "$REWRITTEN" && PRESERVE_MERGES=t
402         test -f "$DOTEST"/strategy && STRATEGY="$(cat "$DOTEST"/strategy)"
403         test -f "$DOTEST"/verbose && VERBOSE=t
404 }
405
406 while test $# != 0
407 do
408         case "$1" in
409         --continue)
410                 is_standalone "$@" || usage
411                 get_saved_options
412                 comment_for_reflog continue
413
414                 test -d "$DOTEST" || die "No interactive rebase running"
415
416                 # Sanity check
417                 git rev-parse --verify HEAD >/dev/null ||
418                         die "Cannot read HEAD"
419                 git update-index --ignore-submodules --refresh &&
420                         git diff-files --quiet --ignore-submodules ||
421                         die "Working tree is dirty"
422
423                 # do we have anything to commit?
424                 if git diff-index --cached --quiet --ignore-submodules HEAD --
425                 then
426                         : Nothing to commit -- skip this
427                 else
428                         . "$DOTEST"/author-script ||
429                                 die "Cannot find the author identity"
430                         if test -f "$DOTEST"/amend
431                         then
432                                 git reset --soft HEAD^ ||
433                                 die "Cannot rewind the HEAD"
434                         fi
435                         export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE &&
436                         git commit --no-verify -F "$DOTEST"/message -e ||
437                         die "Could not commit staged changes."
438                 fi
439
440                 require_clean_work_tree
441                 do_rest
442                 ;;
443         --abort)
444                 is_standalone "$@" || usage
445                 get_saved_options
446                 comment_for_reflog abort
447
448                 git rerere clear
449                 test -d "$DOTEST" || die "No interactive rebase running"
450
451                 HEADNAME=$(cat "$DOTEST"/head-name)
452                 HEAD=$(cat "$DOTEST"/head)
453                 case $HEADNAME in
454                 refs/*)
455                         git symbolic-ref HEAD $HEADNAME
456                         ;;
457                 esac &&
458                 output git reset --hard $HEAD &&
459                 rm -rf "$DOTEST"
460                 exit
461                 ;;
462         --skip)
463                 is_standalone "$@" || usage
464                 get_saved_options
465                 comment_for_reflog skip
466
467                 git rerere clear
468                 test -d "$DOTEST" || die "No interactive rebase running"
469
470                 output git reset --hard && do_rest
471                 ;;
472         -s)
473                 case "$#,$1" in
474                 *,*=*)
475                         STRATEGY="-s "$(expr "z$1" : 'z-[^=]*=\(.*\)') ;;
476                 1,*)
477                         usage ;;
478                 *)
479                         STRATEGY="-s $2"
480                         shift ;;
481                 esac
482                 ;;
483         -m)
484                 # we use merge anyway
485                 ;;
486         -v)
487                 VERBOSE=t
488                 ;;
489         -p)
490                 PRESERVE_MERGES=t
491                 ;;
492         -i)
493                 # yeah, we know
494                 ;;
495         --onto)
496                 shift
497                 ONTO=$(git rev-parse --verify "$1") ||
498                         die "Does not point to a valid commit: $1"
499                 ;;
500         --)
501                 shift
502                 test $# -eq 1 -o $# -eq 2 || usage
503                 test -d "$DOTEST" &&
504                         die "Interactive rebase already started"
505
506                 git var GIT_COMMITTER_IDENT >/dev/null ||
507                         die "You need to set your committer info first"
508
509                 comment_for_reflog start
510
511                 require_clean_work_tree
512
513                 UPSTREAM=$(git rev-parse --verify "$1") || die "Invalid base"
514                 test -z "$ONTO" && ONTO=$UPSTREAM
515
516                 if test ! -z "$2"
517                 then
518                         output git show-ref --verify --quiet "refs/heads/$2" ||
519                                 die "Invalid branchname: $2"
520                         output git checkout "$2" ||
521                                 die "Could not checkout $2"
522                 fi
523
524                 HEAD=$(git rev-parse --verify HEAD) || die "No HEAD?"
525                 mkdir "$DOTEST" || die "Could not create temporary $DOTEST"
526
527                 : > "$DOTEST"/interactive || die "Could not mark as interactive"
528                 git symbolic-ref HEAD > "$DOTEST"/head-name 2> /dev/null ||
529                         echo "detached HEAD" > "$DOTEST"/head-name
530
531                 echo $HEAD > "$DOTEST"/head
532                 echo $UPSTREAM > "$DOTEST"/upstream
533                 echo $ONTO > "$DOTEST"/onto
534                 test -z "$STRATEGY" || echo "$STRATEGY" > "$DOTEST"/strategy
535                 test t = "$VERBOSE" && : > "$DOTEST"/verbose
536                 if test t = "$PRESERVE_MERGES"
537                 then
538                         # $REWRITTEN contains files for each commit that is
539                         # reachable by at least one merge base of $HEAD and
540                         # $UPSTREAM. They are not necessarily rewritten, but
541                         # their children might be.
542                         # This ensures that commits on merged, but otherwise
543                         # unrelated side branches are left alone. (Think "X"
544                         # in the man page's example.)
545                         mkdir "$REWRITTEN" &&
546                         for c in $(git merge-base --all $HEAD $UPSTREAM)
547                         do
548                                 echo $ONTO > "$REWRITTEN"/$c ||
549                                         die "Could not init rewritten commits"
550                         done
551                         MERGES_OPTION=
552                 else
553                         MERGES_OPTION=--no-merges
554                 fi
555
556                 SHORTUPSTREAM=$(git rev-parse --short $UPSTREAM)
557                 SHORTHEAD=$(git rev-parse --short $HEAD)
558                 SHORTONTO=$(git rev-parse --short $ONTO)
559                 git rev-list $MERGES_OPTION --pretty=oneline --abbrev-commit \
560                         --abbrev=7 --reverse --left-right --cherry-pick \
561                         $UPSTREAM...$HEAD | \
562                         sed -n "s/^>/pick /p" > "$TODO"
563                 cat >> "$TODO" << EOF
564
565 # Rebase $SHORTUPSTREAM..$SHORTHEAD onto $SHORTONTO
566 #
567 # Commands:
568 #  p, pick = use commit
569 #  e, edit = use commit, but stop for amending
570 #  s, squash = use commit, but meld into previous commit
571 #
572 # If you remove a line here THAT COMMIT WILL BE LOST.
573 # However, if you remove everything, the rebase will be aborted.
574 #
575 EOF
576
577                 has_action "$TODO" ||
578                         die_abort "Nothing to do"
579
580                 cp "$TODO" "$TODO".backup
581                 git_editor "$TODO" ||
582                         die "Could not execute editor"
583
584                 has_action "$TODO" ||
585                         die_abort "Nothing to do"
586
587                 git update-ref ORIG_HEAD $HEAD
588                 output git checkout $ONTO && do_rest
589                 ;;
590         esac
591         shift
592 done